#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include "types.h"
#include "warning.h"
#include "X.h"
#include "pixmap.h"

//: nactiXPM

Pixmap nactiXPM (char *filename, XImage **xim, Pixmap *shape, XImage **xish)
/*************************************************************************/
{
  Pixmap vysledek;
  XImage *ximage;
  XImage *shapeimage;
  GC lgc;

  // Nactu image pomoci X-ove funkce:
  if(XpmReadFileToImage(display, filename, &ximage, &shapeimage, NULL))
    error("I can't open \"%s\"", filename);

  vysledek = XCreatePixmap(display, root,   // Vytvorim pixmapu barev.
		       ximage->width, ximage->height, ximage->depth);
  lgc = XCreateGC(display, vysledek, 0, 0);
  XPutImage(display, vysledek, lgc, ximage, 0, 0, 0, 0,
		ximage->width, ximage->height);
  XFreeGC(display, lgc);

  if(xim) *xim = ximage;       // XImage barev vratim
  else XDestroyImage(ximage); // nebo odallokuji.

  if(shape){   // Vytvorim pixmapu alfa kanalu
    if(shapeimage){
      *shape = XCreatePixmap(display, root, shapeimage->width,
			     shapeimage->height, shapeimage->depth);
      lgc = XCreateGC(display, *shape, 0, 0); // Vytvorim pixmapu alfa kanalu
      XPutImage(display, *shape, lgc, shapeimage, 0, 0, 0, 0,
		shapeimage->width, shapeimage->height);
      XFreeGC(display, lgc);
    }
    else *shape = None;
  }

  if(xish) *xish = shapeimage;     // XImage alfa kanalu vratim
  else if(shapeimage) XDestroyImage(shapeimage); // nebo odalokuji

  return vysledek;
}

//: nactikqXPM

knp_pixmap *nactiknpXPM (char *filename)
/**************************************/
{
  knp_pixmap *vysledek;
  XImage *ximage;

  vysledek = (knp_pixmap*)mymalloc(sizeof(knp_pixmap));
  vysledek->barvy = nactiXPM(filename, &ximage,
			     &vysledek->akanal, NULL);
  vysledek->height = ximage->height;
  vysledek->width = ximage->width;
  XDestroyImage(ximage);

  return vysledek;
}

//: freeknpPixmap

void freeknpPixmap (knp_pixmap *pxm)
{
  if(pxm->barvy) XFreePixmap(display, pxm->barvy);
  if(pxm->akanal) XFreePixmap(display, pxm->akanal);
  free(pxm);
}
