#include<stdio.h>
#include "types.h"
#include "warning.h"
#include "X.h"
#include "window.h"
#include "loop.h"
#include "pixmap.h"
#include "window.h"
#include "audio.h"

#define OKRAJ    10
#define SIPSPEED 5
#define SIPEND   (2*win_sirka)

float micx, micy, micxx, micyy, deska1y, deska2y, deska1yy, deska2yy;
float sip1xx, sip1x, sip1y, sip2xx, sip2x, sip2y;
int deskavys, deskasir, micvys, micvys;

knp_pixmap *deska1pix, *deska2pix, *micpix, *sip1pix, *sip2pix;
Window deska1w, deska2w, micw, sip1w, sip2w;

char useai;

static int skore1, skore2;

void ai()
{
  int i;

  if(micy + micpix->height/2 < deska1y + deska1pix->height/2) drzi1 = 1;
  else drzi1 = 2;

  strelit1 = 0;
  if(micxx > 0){
    i = (win_sirka-2*OKRAJ)/SIPSPEED - (win_sirka-2*OKRAJ-micx-micpix->width)/micxx;
    if(i < 10 && i > -10) strelit1 = 1;
  }
}

void printskore()
{
  printf("%4d : %d\n", skore1, skore2);
  updateskore(skore1, skore2);
}

void restart(int kekomu)
{
  audio_stop();

  printskore();
  micxx = 1.5*(kekomu*2-3);
  micyy = 2;
  deska1yy = deska2yy = 0;
  micx = (win_sirka-2*OKRAJ-micpix->width)/2;
  micy = (win_vyska-micpix->height)/2;
  deska1y = (win_vyska-deska1pix->height)/2;
  deska2y = (win_vyska-deska2pix->height)/2;

  sip1xx = sip2xx = 0;

  sip1x = OKRAJ-sip1pix->width;
  sip1y = deska1y+deska1pix->height/2;
  sip2x = win_sirka-OKRAJ;
  sip2y = deska2y+deska2pix->height/2;

  audio_start();
}

void vytvordesky()
{
  deska1pix = nactiknpXPM("deska1.xpm");
  deska2pix = nactiknpXPM("deska2.xpm");
  micpix = nactiknpXPM("mic.xpm");
  sip1pix = nactiknpXPM("sip1.xpm");
  sip2pix = nactiknpXPM("sip2.xpm");

  skore1 = skore2 = 0;

  restart(2);

  micw = XCreateSimpleWindow(display, win, micx+OKRAJ, micy,
			     micpix->width,
			     micpix->height, 0,
			     BlackPixel(display,screen),
			     WhitePixel(display,screen));

  XShapeCombineMask (display, micw, ShapeBounding,
		     0, 0, micpix->akanal, ShapeSet);  
  XSetWindowBackgroundPixmap(display, micw, micpix->barvy);
  XMapWindow(display, micw);

  deska1w = XCreateSimpleWindow(display, win, OKRAJ-deska1pix->width, deska1y,
				deska1pix->width,
				deska1pix->height, 0,
				BlackPixel(display,screen),
				WhitePixel(display,screen));

  XShapeCombineMask (display, deska1w, ShapeBounding,
		     0, 0, deska1pix->akanal, ShapeSet);
  XSetWindowBackgroundPixmap(display, deska1w, deska1pix->barvy);
  XMapWindow(display, deska1w);

  deska2w = XCreateSimpleWindow(display, win, win_sirka-OKRAJ, deska2y,
				deska2pix->width,
				deska2pix->height, 0,
				BlackPixel(display,screen),
				WhitePixel(display,screen));

  XShapeCombineMask (display, deska2w, ShapeBounding,
		     0, 0, deska2pix->akanal, ShapeSet);  
  XSetWindowBackgroundPixmap(display, deska2w, deska2pix->barvy);
  XMapWindow(display, deska2w);

  sip1w = XCreateSimpleWindow(display, win, OKRAJ-sip1pix->width, deska1y+deska1pix->height/2,
			      sip1pix->width,
			      sip1pix->height, 0,
			      BlackPixel(display,screen),
			      WhitePixel(display,screen));

  XShapeCombineMask (display, sip1w, ShapeBounding,
		     0, 0, sip1pix->akanal, ShapeSet);
  XSetWindowBackgroundPixmap(display, sip1w, sip1pix->barvy);
  XMapWindow(display, sip1w);

  sip2w = XCreateSimpleWindow(display, win, win_sirka-OKRAJ, deska1y+deska1pix->height/2,
			      sip2pix->width,
			      sip2pix->height, 0,
			      BlackPixel(display,screen),
			      WhitePixel(display,screen));

  XShapeCombineMask (display, sip2w, ShapeBounding,
		     0, 0, sip2pix->akanal, ShapeSet);
  XSetWindowBackgroundPixmap(display, sip2w, sip2pix->barvy);
  XMapWindow(display, sip2w);

  mengraf = 1;
}

static void posundesku(char side, char drzi, int vyska, float *y, float *yy, int sipy, char *block)
{
  if(sipy+1 > 0 && sipy > *y && sipy < *y+vyska){
    *yy = 0;
    *block = 1;
    return;
  }
  *block = 0;

  if(drzi == 0 || drzi == 3)
    *yy *= 0.9;
  else if(drzi == 1){
    if(*yy > 0) *yy *= 0.7;
    *yy -= 1;
  }
  else if(drzi == 2){
    if(*yy < 0) *yy *= 0.7;
    *yy += 1;
  }

  *y += *yy;

  if(*y < -vyska/4){
    *y = 2*(-vyska/4)-*y;
    *yy *= -1;
    audio_deskbounce(side, *yy);
  }
  else if(*y + vyska > win_vyska+vyska/4){
    *y = 2*(win_vyska-vyska+vyska/4)-*y;
    *yy *= -1;
    audio_deskbounce(side|2, *yy);
  }
}

void tik()
{
  int y;
  float hr1, hr2;
  char sip1block, sip2block;

  if(useai) ai();

  if(sip2x < OKRAJ && sip2x+sip2pix->width > OKRAJ) y = sip2y;
  else y = -1;
  posundesku(0, drzi1, deska1pix->height, &deska1y, &deska1yy, y, &sip2block);
  if(sip1x < win_sirka-OKRAJ && sip1x+sip1pix->width > win_sirka-OKRAJ) y = sip1y;
  else y = -1;
  posundesku(1, drzi2, deska2pix->height, &deska2y, &deska2yy, y, &sip1block);

  hr1 = 0;
  hr2 = win_vyska;

  if(sip1xx && micx+OKRAJ+micpix->width/2 > sip1x
     && micx+OKRAJ+micpix->width/2 < sip1x+sip1pix->width){
    if(micy >= sip1y + sip1pix->height/2 + 1) hr1 = sip1y + sip1pix->height/2 + 1;
    else if(micy+micpix->height <= sip1y + sip1pix->height/2) hr2 = sip1y + sip1pix->height/2;
  }

  if(sip2xx && micx+OKRAJ+micpix->width/2 > sip2x
     && micx+OKRAJ+micpix->width/2 < sip2x+sip2pix->width){
    if(micy >= sip2y + sip1pix->height/2 + 1
       && sip2y + sip2pix->height/2 + 1 > hr1) hr1 = sip2y + sip2pix->height/2 + 1;
    else if(micy+micpix->height <= sip2y + sip2pix->height/2 &&
	    sip2y + sip1pix->height/2 < hr2) hr2 = sip2y + sip2pix->height/2;
  }

  //printf("%f\n", micy);

  if(hr2 > hr1+micpix->height) micy += micyy;

  //printf("%f (%f -- %f)  ...  \n", micy, hr1, hr2);

  for(;;){
    if(micy < hr1){
      micyy *= -1;
      micy = 2*hr1-micy;
      if(hr1 == 0) audio_wallbounce(micx, hr1);
      else audio_sipbounce(micx, hr1);
      continue;
    }
    if(micy+micpix->height > hr2){
      micyy *= -1;
      micy = 2*(hr2-micpix->height)-micy;
      if(hr2 == win_vyska) audio_wallbounce(micx, hr2);
      else audio_sipbounce(micx, hr1);
      continue;
    }
    break;
  }

  //printf("    %f (%f -- %f)\n", micy, hr1, hr2);

  micx += micxx;
  if(micx < 0 && micx-micxx >= 0 && deska1y <= micy+micpix->height/2 &&
     deska1y+deska1pix->height >= micy+micpix->height/2){
    micx *= -1;
    micxx *= -1;
    micxx += 0.5;
    deska1yy = micyy = (deska1yy + micyy)/2;
    audio_sidebounce(0, OKRAJ, micy);
  }
  else if(micx-micxx <= win_sirka-2*OKRAJ-micpix->width &&
	  micx > win_sirka-2*OKRAJ-micpix->width &&
	  deska2y <= micy+micpix->height/2 &&
	  deska2y+deska2pix->height >= micy+micpix->height/2){
    micx = 2*(win_sirka-2*OKRAJ-micpix->width) - micx;
    micxx *= -1;
    micxx -= 0.5;
    deska2yy = micyy = (deska2yy + micyy)/2;
    audio_sidebounce(0, win_sirka-OKRAJ, micy);
  }

  if(micx < -OKRAJ*2-20-micpix->width){
    skore2++;
    restart(1);
  }
  else if(micx > win_sirka+20){
    skore1++;
    restart(2);
  }

  XMoveWindow(display, micw, micx+OKRAJ, micy);
  XMoveWindow(display, deska1w, OKRAJ-deska1pix->width, deska1y);
  XMoveWindow(display, deska2w, win_sirka-OKRAJ, deska2y);

  if(strelit1){
    if(!sip1xx) audio_sipstart(0, sip1x, sip1y, sip1pix->width);
    sip1xx = SIPSPEED;
  }
  if(strelit2){
    if(!sip2xx) audio_sipstart(1, sip2x, sip2y, sip2pix->width);
    sip2xx = -SIPSPEED;
  }

  if(sip1xx){
    sip1x += sip1xx;

    if(((int)(SIPEND - (sip1x - (OKRAJ-sip1pix->width))))/SIPSPEED == AUDIO_SIPRESET)
      audio_sipreload(OKRAJ, deska2y+deska2pix->height/2);

    if(sip1x - (OKRAJ-sip1pix->width) > SIPEND){
      sip1xx = 0;
      audio_sipstop(0);
    }
    else audio_sipmove(0, sip1x, sip1block);
  }
  if(!sip1xx){
    sip1x = OKRAJ-sip1pix->width;
    sip1y = deska1y+deska1pix->height/2;
  }
  if(sip2xx){
    sip2x += sip2xx;
    if(((int)(SIPEND - ((win_sirka-OKRAJ) - sip2x)))/SIPSPEED == AUDIO_SIPRESET)
      audio_sipreload(win_sirka-OKRAJ, deska2y+deska2pix->height/2);

    if((win_sirka-OKRAJ) - sip2x > SIPEND){
      sip2xx = 0;
      audio_sipstop(1);
    }
    else audio_sipmove(1, sip2x, sip2block);
  }
  if(!sip2xx){
    sip2x = win_sirka-OKRAJ;
    sip2y = deska2y+deska2pix->height/2;
  }

  XMoveWindow(display, sip1w, sip1x, sip1y-sip1pix->height/2);
  XMoveWindow(display, sip2w, sip2x, sip2y-sip2pix->height/2);

  mengraf = 1;
}

int main(int argc, char **argv)
{
  gargc = argc;
  gargv = argv;

  if(argc == 1) useai = 0;
  else if(argc == 2 && !strcmp(argv[1], "-ai")) useai = 1;
  else{
    printf("Usage:  pong [-ai]\n");
    printf("\n");
    printf("Controls:\n");
    printf("Left player: 'z' = move up, 'c' = move down, 'x' = shoot\n");
    printf("Right player: 'left' = move down, 'right' = move up, 'down' = shoot\n");
    printf("'p' = pause\n");
    printf("'Esc' = exit\n");
    printf("\n");
    printf("Option: -ai     The left player is controlled by computer.\n");

    return 0;
  }

  initX();
  vytvorokno();
  audio_init(argc, argv);
  vytvordesky();
  setdelay(0, 20000);
  loop();

  return 0;
}
